<template>
  <div class="content d-flex flex-col flex-ai-center flex-jc-center">
    <div class="navbar d-flex flex-row flex-ai-center ph-5">
      <v-icon name="fire" scale="2.2" style="width: 30px"/>
      <span class="mv-0 mr-2 title">matcha</span>
      <!-- Login button -->
      <button class="icon-button ml-auto mr-2 login-button"
        @click="showLogin = !showLogin">
        LOG IN
      </button>
      <!-- Menu button -->
      <button class="icon-button p-1 menu-button"
        @click="showLogin = true">
        <v-icon name="bars" scale="2"/>
      </button>
    </div>

    <div class="ph-3">
      <img src="https://imgur.com/4NyzdtO.png" class="slogan">
      <h2 class="mb-1">WHAT WILL YOUR CHOICES SAY ABOUT YOU?</h2>
      <h3 class="mt-0" style="font-weight: 300">
        Only on Matcha | Sundays 6 p.m.
      </h3>
    </div>

    <PopupContainer :show.sync="showLogin" :canClose="canClose">
      <div class="login d-flex flex-col p-5 ph-sm-1 pb-1 flex-ai-center">
        <button class="icon-button text-muted close-button popup-close">
          <v-icon>
            <v-icon name="times"/>
            <v-icon name="regular/circle" scale="1.5"/>
          </v-icon>
        </button>

        <!-- <v-icon name="fire" scale="2" class="mt-1"/> -->
        <Error v-if="error" :error.sync="error" round class="mt-4 mb-5 w-100"/>
        <img src="@/assets/logo.png" width="32">

        <Tab :page="loginPage" class="w-100">
          <!-- Main page -->
          <div data-page="tab-page-main" class="d-flex flex-col ph-1 flex-ai-center w-100">
            <h2 class="mh-5 mt-1"><i>GET STARTED</i></h2>
            <Policy by="clicking Log in"/>
            <button class="primary w-100 mt-3 text-small"
              @click="loginPage = 'login'">
              Login with username
            </button>
            <button class="mt-1 w-100 mb-5 text-small"
              @click="loginPage = 'register'">
              Create an account
              </button>
            <a class="text-smaller">Trouble logging in?</a>
            <h3 class="mt-5"><i>GET THE APP!</i></h3>
            <div class="d-flex flex-row w-100 flex-jc-center mb-5">
              <button class="icon-button mh-3" disabled title="Coming soon...">
                <v-icon name="brands/apple" scale="3"/>
              </button>
              <button class="icon-button mh-3" disabled title="Coming soon...">
                <v-icon name="brands/android" scale="3"/>
              </button>
            </div>
          </div>
          <!-- Login page -->
          <div data-page="tab-page-login" class="d-flex flex-col ph-1 flex-ai-center w-100 ph-2">
            <button class="icon-button text-secondary" @click="loginPage = 'main'"
              style="position: absolute; left: 6px; top: 8px; height: 30px;">
              <v-icon name="arrow-left"/>
            </button>

            <h2 class="mh-5 mt-1"><i>LOG IN</i></h2>

            <form @submit="onLogin" class="d-flex flex-col w-100">

              <div class="input-group w-100">
                <v-icon name="user"/>
                <input type="text" placeholder="Username" v-model="username">
              </div>

              <div class="input-group w-100">
                <v-icon name="lock"/>
                <input type="password" placeholder="Password" v-model="password">
              </div>

              <a href="#forgotpass" class="mt-3 text-smaller">
                Forgot your password?
              </a>

              <AsyncButton class="primary mv-5" :fn="onLogin">
                Log in
              </AsyncButton>

              <Policy by="Logging in" class="mb-4"/>

            </form>
          </div>
          <!-- Validate page -->
          <Validate data-page="tab-page-validate"/>
          <!-- Setup page -->
          <Setup data-page="tab-page-setup"/>
          <!-- Register page -->
          <Register data-page="tab-page-register"/>
          <!-- Forgot password page -->
          <ForgotPassword data-page="tab-page-forgotpass"/>
        </Tab>
      </div>
    </PopupContainer>
  </div>
</template>

<script>
import PopupContainer from '@/components/PopupContainer.vue';
import Tab from '@/components/Tab.vue';
import Policy from '@/components/Policy.vue';
import Error from '@/components/Error.vue';
import Validate from '@/components/welcome-pages/Validate.vue';
import Setup from '@/components/welcome-pages/Setup.vue';
import Register from '@/components/welcome-pages/Register.vue';
import ForgotPassword from '@/components/welcome-pages/ForgotPassword.vue';

import { mapState } from 'vuex';

export default {
  data: () => ({
    showLogin: false,
    loginPage: 'main',
    pages: [ 'main', 'login', 'register', 'validate', 'forgotpass', 'setup' ],
    logging: false,
    username: null,
    password: null,
    error: null,
  }),
  computed: {
    ...mapState([ 'user' ]),
    canClose() {
      return ['#validate', '#setup'].indexOf(this.$route.hash) === -1;
    },
  },
  components: {
    PopupContainer,
    Tab,
    Policy,
    Error,
    Validate,
    Setup,
    Register,
    ForgotPassword,
  },
  watch: {
    $route(to) {
      this.selectPage(to.hash.substr(1));
    },
    loginPage(to) {
      if (this.$route.hash !== `#${to}`)
        this.$router.push({ hash: to });
    },
  },
  methods: {
    async onLogin(e) {
      e.preventDefault();

      if (this.logging) return ;

      if (!this.username || this.username.trim() == '') return ;
      if (!this.password || this.password.trim() == '') return ;

      this.logging = true;
      this.error = null;

      try {
        let { data } = await this.$store.dispatch('login', {
          username: this.username,
          password: this.password,
        });

        if (!data.user.verified)
          this.selectPage('validate');
        else if (!data.user.first_setup)
          this.selectPage('setup');
        else
          this.$router.push('/');
      }
      catch(err) {
        if (err.response)
          this.error = err.response.data.error;
      }
      finally {
        this.logging = false;
      }
    },
    selectPage(name) {
      if (this.$store.state.logged) {
        // If user is not verified
        if (!this.$store.state.user.verified) {
          if (this.$route.hash != '#validate')
            return this.$router.replace({ hash: '#validate' });
        }
        // If user didn't setup their account
        else if (!this.$store.state.user.first_setup) {
          if (this.$route.hash != '#setup')
            return this.$router.replace({ hash: '#setup' });
        }
        // Else
        else
          return this.$router.replace('/');
      }

      if (name === '')
        return ;
      if (this.pages.indexOf(name) == -1)
        return this.$router.replace({ hash: '' });

      switch(name) {
        case 'validate':
          // If the user is already verified, just ignore
          if (this.$store.state.user && this.$store.state.user.verified)
            return this.$router.replace({ hash: '' });
          break;
      }

      this.loginPage = name;
      this.showLogin = true;
    }
  },
  mounted() {
    this.selectPage(this.$route.hash.substr(1));
  }
};
</script>

<style scoped>
.content {
  min-height: 100%;
  background-image: url("https://imgur.com/FfLS9jZ.jpg");
  background-size: cover;
  background-repeat: no-repeat;
  background-position: center;

  position: relative;

  color: white;
}

.navbar {
  position: absolute;

  top: 0;
  left: 0;

  width: 100%;
  height: 96px;

  max-width: 100%;

  font-weight: bold;
  font-size: 18pt;
}

.title { font-size: 30pt; }

.navbar * { color: white; }

.navbar > .fa-icon:first-of-type { margin-right: 6px; }

.slogan { width: 400px; max-width: 100%; }

.login-button {
  background: white;
  color: var(--color-primary);
  padding: 1rem 1.5rem;
  font-size: 11pt;
  font-weight: bold;
  border-radius: 4px;
  transition: all .1s ease-in-out;
}

.login-button:hover {
  background: linear-gradient(to right, var(--color-primary), var(--color-orange));
  color: white;
}

.login-button:active {
  transition: all 0s ease-in-out;
  background: linear-gradient(to right, var(--color-primary), var(--color-orange) 99%);
  color: white;
}

.login {
  border-radius: 8px;
  background: white;
  color: var(--color-dark);
  position: relative;

  width: 440px;
  max-width: 100%;

  min-height: min-content;

  /* transition: all 1s ease-in-out; */
}

.login .close-button {
  position: absolute;
  top: 8px;
  right: 6px;
}

.login .close-button * { pointer-events: none; }

@media only screen and (max-width: 550px) {
  .navbar {
    padding: 0 1em !important;
  }

  .navbar .title {
    font-size: 25pt;
  }

  button.login-button {
    display: none;
  }

  button.menu-button {
    margin-left: auto !important;
    margin-right: .5em;
  }
}

</style>
